;Master_controller_ATMEGA128_asm.asm		29.09.2006


;     AVR   Atmel
;  ATMEGA128.
;  3,6864 MHz.



.include "m128def.inc"

.def	place		= r13		
.def	string		= r14

.def	temp		= r16		;  

.def	byte		= r17		
.def	page_lcd	= r18
.def	col			= r19

.def	scan_keyb	= r20
.def	simbol		= r21

.def	data_comm	= r22
.def	left_right	= r23

.def	error		= r24

.def 	delay		= r28			;  
;******************************************************************************************
;PORTD
.equ	E		= 7
.equ	RD_WR	= 6
.equ	A0		= 5
.equ	LIGHT	= 4				; 
.equ	TM		= 2				;    Touch Memory

;PORTG
.equ	RES		= 2				; 
.equ	E1		= 0
.equ	E2		= 1

;command
.equ 	DISPLAY_ON 	= 0b00111111
.equ	SET_PAGE 	= 0b10111000
.equ	SET_ADDRESS = 0b01000000
.equ	START_LINE 	= 0b11000000

.equ	BUSY	= 7

.equ	DELAY_1mcs	= 1
.equ	DELAY_10mcs	= 10
.equ	DELAY_77mcs	= 77

.equ	SECOND	= $0100
.equ	MIN		= $0101
.equ	HOUR	= $0102
.equ	WEEK	= $0103
.equ	DAY		= $0104
.equ	MONTH	= $0105
.equ	YEAR	= $0106


;******************************************************************************************
.org 0x00

 	rjmp 	start
;******************************************************************************************
;  
.org	0x0002	jmp	start	;ext_int_0 - external interrupt request 0
.org	0x0004	jmp	start	;ext_int_1 - external interrupt request 1
.org	0x0006	jmp	start	;ext_int_2 - external interrupt request 2
.org	INT3addr  
	jmp	ext_int_3			;ext_int_3 - external interrupt request 3 
.org	0x000a	jmp	start	;ext_int_4 - external interrupt request 4
.org	0x000c	jmp	start	;ext_int_5 - external interrupt request 5  
.org	0x000e	jmp	start	;ext_int_6 - external interrupt request 6
.org	0x0010	jmp	start	;ext_int_7 - external interrupt request 7
.org	0x0012	jmp	start	;tim2_comp -  timer 2 compare match	
.org	0x0014	jmp	start	;tim2_ovf -  timer 2 overflow		
.org	0x0016	jmp	start	;tim1_capt -  timer 1 capture event 
.org	0x0018	jmp	start	;tim1_compa - timer 1 compare match a
.org	0x001a	jmp	start	;tim1_compb - timer 1 compare match b 	
.org	0x001c	jmp	start	;tim1_ovf - timer 1  overflow		
.org	0x001e	jmp	start	;tim0_comp - timer 0 compare match		
.org	OVF0addr
	jmp	int_timer0_ovf		;tim0_ovf - timer counter 0 overflow
.org	0x0022	jmp	start	;spi_stc - spi serial transfer complete 	    
.org	0x0024	jmp	start	;usart0_rxc - usart reception complete	
.org	0x0026	jmp	start	;usart0_udre - usart0 data register is empty		
.org	0x0028	jmp	start	;usart0_tx - usart0 transmission complete
.org	0x002a	jmp	start	;adc - dc conversion complete 
.org	0x002c	jmp	start	;ee_ready - eeprom ready interrupt
.org	0x002e	jmp	start	;analog_comp - the interrupt from the analog comparator match	
.org	0x0030	jmp	start	;timer1_compC - timercounter compare match c 	
.org	0x0032	jmp	start	;timer3_capt - timer_counter 3 capture event 
.org	0x0034	jmp	start	;timer3_compa - timer counter 3 compare match a
.org	0x0036	jmp	start	;timer3_compb - timer counter 3 compare match b 
.org	0x0038	jmp	start	;timer3_compc - timer counter 3 compare match c		
.org	0x003a	jmp	start	;timer3_ovf -  timer counter 3 overflow
.org	0x003c	jmp	start	;usart_1_rxc - usart1 recieve rxc complete		
.org	0x003e	jmp	start	;usart1_udre - usart1 data register empty
.org	0x0040	jmp	start	;usart_1_txc - usart1 transmit  complete	
.org	0x0042	jmp	start	;twi - twi interrupt	 
.org	0x0044	jmp	start	;spm_ready - store programm memory ready
;******************************************************************************************
start:

	cli							;  

;    1     

	wdr
	ldi		temp, (1<<WDTOE)|(1<<WDE)|(1<<WDP2)|(1<<WDP1)
	out		WDTCR, temp													

	ldi		temp, low(RAMEND)
	out		SPL, temp			; 
	ldi		temp, high(RAMEND)
	out		SPH, temp			; 

	ldi 	temp, (1<<ACD)		; 
	out 	ACSR, temp

	ldi		temp, 0b11111111	
	out		PORTA, temp
	ldi 	temp, 0b11110000	
	out		DDRA, temp

	ldi		temp, 0b00000000	
	out		PORTC, temp
	ldi 	temp, 0b00000000	
	out		DDRC, temp

	ldi 	temp, 0b00000000	
	out 	PORTD, temp			
	ldi	 	temp, 0b11110000	
	out 	DDRD, temp			
	
	ldi		temp, 0b00000100	
	sts		PORTG, temp
	ldi 	temp, 0b00011111	
	sts		DDRG, temp

	clr		error
	ldi		scan_keyb, 0b10001000

	ldi 	temp, $80
	out 	TCNT0, temp			;     T0  $80
	ldi 	temp, (1<<CS02)|(0<<CS01)|(1<<CS00)	;  T0  
	out 	TCCR0, temp			;   1024
	ldi 	temp, (1<<TOIE0)	;     T0
	out 	TIMSK, temp

	ldi		temp, (1<<ISC30)	;      INT3
	sts		EICRA, temp

	ldi		temp, (1<<INT3)		;   INT3
	out		EIMSK, temp

;   SCL  TWI

	ldi		temp, 1
	sts		TWBR, temp
	clr 	temp				
	sts		TWSR, temp
;******************************************************************************************
;  

	wdr
		
	rcall	initial_LCD

	rcall	black_screen

	ldi		delay, 50
	rcall	pause

	rcall	clean_screen

	ldi		delay, 10
	rcall	pause

	rcall	picture

	ldi		delay, 50
	rcall	pause

	rcall	clean_screen

	rcall	initial_LCD

	rcall	print_simbol

	ldi		delay, 50
	rcall	pause

	rcall	clean_screen

	rcall	clock

	clr		place
	clr		string

	sei							;  

cycle:
	sei
	wdr
	cli
	cpi 	simbol, 0
	breq	cycle
	rcall	print_one_simbol
	ldi		delay, 2
	rcall	pause
	rjmp	cycle
;******************************************************************************************
;   
;******************************************************************************************
ext_int_3:

	cli

;  REPEATED START

	rcall	repeated_start
	cpi 	error, $0EE
	breq 	error_twi_int_1

;     

	rcall	sla_w
	cpi 	error, $0EE
	breq 	error_twi_int_1
	rjmp	contin_ext_int_3

error_twi_int_1:
	rjmp	error_twi_int
;   ,   
;    (     )

contin_ext_int_3:
	clr		byte
	rcall	write_byte_twi
	cpi 	error, $0EE
	breq 	error_twi_int

;  REPEATED START

	rcall	repeated_start
	cpi 	error, $0EE
	breq 	error_twi_int

;     

	rcall	sla_r
	cpi 	error, $0EE
	breq 	error_twi_int

;    00H, 01H, 02H, 03H, 04H, 05H, 06H

	rcall	read_byte_twi
	cpi 	error, $0EE
	breq 	error_twi_int

	lds 	temp, TWDR
	andi	temp, 0b01111111
	sts		SECOND, temp

	rcall	read_byte_twi
	cpi 	error, $0EE
	breq 	error_twi_int

	lds 	temp, TWDR
	andi	temp, 0b01111111
	sts		MIN, temp

	rcall	read_byte_twi
	cpi 	error, $0EE
	breq 	error_twi_int

	lds 	temp, TWDR
	andi	temp, 0b00111111
	sts		HOUR, temp

	rcall	read_byte_twi
	cpi 	error, $0EE
	breq 	error_twi_int

	lds 	temp, TWDR
	andi	temp, 0b00000111
	sts		WEEK, temp

	rcall	read_byte_twi
	cpi 	error, $0EE
	breq 	error_twi_int

	lds 	temp, TWDR
	andi	temp, 0b00111111
	sts		DAY, temp

	rcall	read_byte_twi
	cpi 	error, $0EE
	breq 	error_twi_int

	lds 	temp, TWDR
	andi	temp, 0b00111111
	sts		MONTH, temp

	rcall	last_byte_twi
	cpi 	error, $0EE
	breq 	error_twi_int

	lds 	temp, TWDR
	andi	temp, 0b11111111
	sts		YEAR, temp

	rcall	indication_clock	

error_twi_int:
	sei
	ret
;******************************************************************************************
int_timer0_ovf:

	clr 	temp				;  T0  
	out 	TCCR0, temp			;   1024
	ldi 	temp, $80
	out 	TCNT0, temp			;     T0  $80

	wdr
	push	temp
	clr		simbol
	lsl		scan_keyb
	ldi		temp,0b11110000
	and		temp, scan_keyb
	brne	contin
	ldi		scan_keyb, 0b00010001
	bclr	0
contin:
	ldi		temp,0b11111111
	eor		scan_keyb, temp
	out		PORTA, scan_keyb
	nop
	in 		temp, PINA
	andi	temp, 0b00001111
	sbrs	scan_keyb,4
	rjmp	col_1
	sbrs	scan_keyb,5
	rjmp	col_2
	sbrs	scan_keyb,6
	rjmp	col_3
	sbrs	scan_keyb,7
	rjmp	col_4

col_1:
	sbrs	temp, 0
	ldi		simbol, '1'
	sbrs	temp, 1
	ldi		simbol, '4'
	sbrs	temp, 2
	ldi		simbol, '7'
	sbrs	temp, 3
	ldi		simbol, '*'
	rjmp	simbol_out
col_2:
	sbrs	temp, 0
	ldi		simbol, '2'
	sbrs	temp, 1
	ldi		simbol, '5'
	sbrs	temp, 2
	ldi		simbol, '8'
	sbrs	temp, 3
	ldi		simbol, '0'
	rjmp	simbol_out
col_3:
	sbrs	temp, 0
	ldi		simbol, '3'
	sbrs	temp, 1
	ldi		simbol, '6'
	sbrs	temp, 2
	ldi		simbol, '9'
	sbrs	temp, 3
	ldi		simbol, '='
	rjmp	simbol_out
col_4:
	sbrs	temp, 0
	ldi		simbol, '>'
	sbrs	temp, 1
	ldi		simbol, '<'
	sbrs	temp, 2
	ldi		simbol, '.'
	sbrs	temp, 3
	ldi		simbol, '-'

simbol_out:
	cpi		simbol, $00
	breq	exit
	cpi		simbol, '1'
	brne	s_2
	ldi		zh, HIGH (2*n_1)
	ldi		zl, LOW (2*n_1)
	rjmp	exit_int_timer0_ovf
exit:
	rjmp	exit_int_timer0_ovf
s_2:
	cpi		simbol, '2'
	brne	s_3
	ldi		zh, HIGH (2*n_2)
	ldi		zl, LOW (2*n_2)
	rjmp	exit_int_timer0_ovf
s_3:
	cpi		simbol, '3'
	brne	s_4
	ldi		zh, HIGH (2*n_3)
	ldi		zl, LOW (2*n_3)
	rjmp	exit_int_timer0_ovf
s_4:
	cpi		simbol, '4'
	brne	s_5
	ldi		zh, HIGH (2*n_4)
	ldi		zl, LOW (2*n_4)
	rjmp	exit_int_timer0_ovf
s_5:
	cpi		simbol, '5'
	brne	s_6
	ldi		zh, HIGH (2*n_5)
	ldi		zl, LOW (2*n_5)
	rjmp	exit_int_timer0_ovf
s_6:
	cpi		simbol, '6'
	brne	s_7
	ldi		zh, HIGH (2*n_6)
	ldi		zl, LOW (2*n_6)
	rjmp	exit_int_timer0_ovf
s_7:
	cpi		simbol, '7'
	brne	s_8
	ldi		zh, HIGH (2*n_7)
	ldi		zl, LOW (2*n_7)
	rjmp	exit_int_timer0_ovf
s_8:
	cpi		simbol, '8'
	brne	s_9
	ldi		zh, HIGH (2*n_8)
	ldi		zl, LOW (2*n_8)
	rjmp	exit_int_timer0_ovf
s_9:
	cpi		simbol, '9'
	brne	s_0
	ldi		zh, HIGH (2*n_9)
	ldi		zl, LOW (2*n_9)
	rjmp	exit_int_timer0_ovf
s_0:
	cpi		simbol, '0'
	brne	s_dot
	ldi		zh, HIGH (2*n_0)
	ldi		zl, LOW (2*n_0)
	rjmp	exit_int_timer0_ovf
s_dot:
	cpi		simbol, '.'
	brne	s_z
	ldi		zh, HIGH (2*n_dot)
	ldi		zl, LOW (2*n_dot)
	rjmp	exit_int_timer0_ovf
s_z:
	cpi		simbol, '*'
	brne	s_r
	ldi		zh, HIGH (2*n_z)
	ldi		zl, LOW (2*n_z)
	rjmp	exit_int_timer0_ovf
s_r:
	cpi		simbol, '='
	brne	s_min
	ldi		zh, HIGH (2*n_r)
	ldi		zl, LOW (2*n_r)
	rjmp	exit_int_timer0_ovf
s_min:
	cpi		simbol, '-'
	brne	s_arrow_r
	ldi		zh, HIGH (2*n_min)
	ldi		zl, LOW (2*n_min)
s_arrow_r:
	cpi		simbol, '>'
	brne	s_arrow_l
	ldi		zh, HIGH (2*arrow_r)
	ldi		zl, LOW (2*arrow_r)
	rjmp	exit_int_timer0_ovf
s_arrow_l:
	cpi		simbol, '<'
	brne	exit_int_timer0_ovf
	ldi		zh, HIGH (2*arrow_l)
	ldi		zl, LOW (2*arrow_l)
exit_int_timer0_ovf:
	ldi		temp,0b11111111
	eor		scan_keyb, temp
	pop		temp
	ldi 	temp, (1<<CS02)|(0<<CS01)|(1<<CS00)	;  T0  
	out 	TCCR0, temp			;   1024
	reti						;exit_int_timer0_ovf
;******************************************************************************************
;  
;******************************************************************************************
write_comm_L:

	ldi		left_right,(1<<E1)
	clr		data_comm
	rcall   write_byte
	ret
;******************************************************************************************
write_comm_R:

	ldi		left_right,(1<<E2)
	clr		data_comm
	rcall   write_byte
	ret
;******************************************************************************************
write_data_L:

	ldi		left_right,(1<<E1)
	ldi		data_comm, (1<<A0)
	rcall   write_byte
	ret
;******************************************************************************************
write_data_R:

	ldi		left_right,(1<<E2)
	ldi		data_comm, (1<<A0)
	rcall   write_byte
	ret
;******************************************************************************************
write_byte:

	wdr
	ldi 	temp, 0b00000000	
	out		DDRC, temp
	ldi 	temp, 0b11111111	
	out		PORTC, temp
	ldi		temp, (1<<RD_WR)|(1<<LIGHT)
	out		PORTD, temp
	ldi		temp, (1<<RES)
	or		temp, left_right
	sts		PORTG, temp
	ldi		delay, DELAY_1mcs
	rcall	pause_1
	ldi		temp, (1<<RD_WR)|(1<<E)|(1<<LIGHT)
	out		PORTD, temp
	ldi		delay, DELAY_1mcs
	rcall	pause_1
wait_busy:
	sbic 	PINC, BUSY			;  
	rjmp 	wait_busy
	ldi		temp, (1<<RD_WR)|(0<<E)|(1<<LIGHT)
	out		PORTD, temp
	ldi		delay, DELAY_1mcs
	rcall	pause_1
	ldi 	temp, 0b11111111	
	out		DDRC, temp
	ldi		temp, (0<<RD_WR)|(0<<E)|(1<<LIGHT)
	or		temp, data_comm
	out		PORTD, temp
	out		PORTC, byte
	ldi		delay, DELAY_1mcs
	ldi		temp, (1<<E)|(1<<LIGHT)
	or		temp, data_comm
	out		PORTD, temp
	ldi		delay, DELAY_1mcs
	rcall	pause_1
	ldi		temp, (0<<E)|(1<<LIGHT)
	or		temp, data_comm
	out		PORTD, temp
	ldi		delay, DELAY_1mcs
	rcall	pause_1
	ret
;******************************************************************************************
initial_LCD:

	wdr
	sbi 	PORTD, LIGHT	
	ldi 	temp, (1<<RES)	
	sts		PORTG, temp

	ldi 	temp, (0<<RES)	
	sts		PORTG, temp
	ldi		delay, DELAY_1mcs
	rcall	pause_1
	ldi 	temp, (1<<RES)	
	sts		PORTG, temp
	ldi		delay, DELAY_10mcs
	rcall	pause_1

	ldi 	byte, START_LINE	
	rcall	write_comm_L
	rcall	write_comm_R

	ldi 	byte, DISPLAY_ON	
	rcall	write_comm_L
	rcall	write_comm_R

	ldi 	byte, SET_PAGE	
	rcall	write_comm_L
	rcall	write_comm_R

	ldi 	byte, SET_ADDRESS	
	rcall	write_comm_L
	rcall	write_comm_R
	ret
;******************************************************************************************
full_screen:

	clr		page_lcd
	clr		col
cycle_full_screen:
	ldi 	byte, SET_PAGE
	or	 	byte, page_lcd	
	rcall	write_comm_L
	rcall	write_comm_R
	mov 	byte, simbol	
	rcall	write_data_L
	rcall	write_data_R
	inc		col
	cpi		col, 64	
	brlo	cycle_full_screen
	clr		col
	inc		page_lcd
	cpi		page_lcd, 8	
	brne	cycle_full_screen
	ret
;******************************************************************************************
clean_screen:

	clr		simbol
	rcall	full_screen
	ret
;******************************************************************************************
black_screen:
	
	ldi		simbol, $0FF
	rcall	full_screen
	ret
;******************************************************************************************
picture:

	clr		r1
	clr		page_lcd
	clr		col
	ldi		zh, HIGH (2*picture_mas)
	ldi		zl, LOW (2*picture_mas)
	ldi 	byte, SET_ADDRESS	
	rcall	write_comm_L
cycle_picture:
	ldi 	byte, SET_PAGE
	or	 	byte, page_lcd	
	rcall	write_comm_L
	rcall	write_comm_R
	lpm
	adiw	zl, 1
	adc		zh,r1
	mov 	byte, r0
	rcall	write_data_L
	inc		col
	cpi		col, 64	
	brlo	cycle_picture

	ldi 	byte, SET_ADDRESS	
	rcall	write_comm_R
cycle_picture_1:
	lpm
	adiw	zl, 1
	adc		zh,r1
	mov 	byte, r0
	rcall	write_data_R
	inc		col
	cpi		col, 128	
	brlo	cycle_picture_1
	clr		col
	inc		page_lcd
	cpi		page_lcd, 8	
	brne	cycle_picture
	ret
;******************************************************************************************
write_simbol_LCD:

	clr		col
cycle_write_simbol_LCD:
	lpm
	adiw	zl, 1
	adc		zh,r1
	mov 	byte, r0
	rcall	write_byte
	inc		col
	cpi		col, 8	
	brlo	cycle_write_simbol_LCD
	ret
;******************************************************************************************
print_one_simbol:

	ldi 	byte, SET_PAGE	
	or		byte, string			
	rcall	write_comm_R
	rcall	write_comm_L
	ldi 	byte, SET_ADDRESS
	or		byte, place			
	rcall	write_comm_R
	rcall	write_comm_L

	ldi		data_comm, (1<<A0)

	ldi		left_right,(1<<E1)
	sbrc	place, 6
	ldi		left_right,(1<<E2)
		
	rcall	write_simbol_LCD
	
	add		place, col
	sbrc	place, 7
	rjmp	branch
	ret
branch:
	clr		place
	inc 	string
	sbrs	string, 0
	ret
	sbrs	string, 1
	ret
	sbrs	string, 2
	ret
	clr		string
	ret
;******************************************************************************************
print_simbol:

	clr		place
	clr		string
	clr		simbol
	ldi		zh, HIGH (2*simbol_table)
	ldi		zl, LOW (2*simbol_table)
cycle_simbol_print:
	rcall	print_one_simbol
	inc		simbol
	cpi		simbol, 17	
	brlo	cycle_simbol_print
	clr		simbol
	ret
;******************************************************************************************
clock:

	cli

;  START

	rcall	start_twi
	cpi 	error, $0EE
	breq 	error_twi

;     

	rcall	sla_w
	cpi 	error, $0EE
	breq 	error_twi

;   ,   
;    (   )

	clr		byte
	rcall	write_byte_twi
	cpi 	error, $0EE
	breq 	error_twi

;  REPEATED START

	rcall	repeated_start	
	cpi 	error, $0EE
	breq 	error_twi

;     

	rcall	sla_r
	cpi 	error, $0EE
	breq 	error_twi

;    00H

	rcall	read_byte_twi
	cpi 	error, $0EE
	breq 	error_twi

	lds 	temp, TWDR
	sbrs	temp, 7
	rjmp	error_twi		;    
;------------------------------------------------------------------------------------------	
;   

;  REPEATED START

	rcall	repeated_start	
	cpi 	error, $0EE
	breq 	error_twi

;     

	rcall	sla_w
	cpi 	error, $0EE
	breq 	error_twi

;   ,   
;    (   )

	clr		byte
	rcall	write_byte_twi
	cpi 	error, $0EE
	breq 	error_twi

;    

;
	clr		byte				;00H
	rcall	write_byte_twi
	cpi 	error, $0EE
	breq 	error_twi

;
	ldi		byte, $45			;01H
	rcall	write_byte_twi
	cpi 	error, $0EE
	breq 	error_twi

;
	ldi		byte, $17			;02H
	rcall	write_byte_twi
	cpi 	error, $0EE
	breq 	error_twi

; 
	ldi		byte, $01			;03H
	rcall	write_byte_twi
	cpi 	error, $0EE
	breq 	error_twi

;
	ldi		byte, $05			;04H
	rcall	write_byte_twi
	cpi 	error, $0EE
	breq 	error_twi

;
 	ldi		byte, $03			;05H
	rcall	write_byte_twi
	cpi 	error, $0EE
	breq 	error_twi

;
	ldi		byte, 07			;06H
	rcall	write_byte_twi
	cpi 	error, $0EE
	breq 	error_twi


	ldi		byte, 0b00010000	;07H	  SWQ/OUT  1  
	rcall	write_byte_twi
	cpi 	error, $0EE
	breq 	error_twi
;------------------------------------------------------------------------------------------	
error_twi:
	sei	
	ret
;******************************************************************************************
;      

indication_clock:

	wdr

	ldi 	byte, SET_PAGE + 7	
	rcall	write_comm_R
	rcall	write_comm_L
	ldi 	byte, SET_ADDRESS	
	rcall	write_comm_R
	rcall	write_comm_L

	ldi		data_comm, (1<<A0)

	lds 	temp,DAY
	rcall 	tetradaH

	lds 	temp,DAY
	rcall 	tetradaL

	ldi 	byte, 0
	rcall 	write_byte
	ldi 	byte, 0b01000010
	rcall 	write_byte
	ldi 	byte, 0
	rcall 	write_byte
	ldi 	byte, 0
	rcall 	write_byte

	lds 	temp,MONTH
	rcall 	tetradaH

	lds 	temp,MONTH
	rcall 	tetradaL

	ldi 	byte, 0
	rcall 	write_byte
	ldi 	byte, 0b01000010
	rcall 	write_byte
	ldi 	byte, 0
	rcall 	write_byte
	ldi 	byte, 0
	rcall 	write_byte

	lds 	temp,YEAR
	rcall 	tetradaH
	
	lds 	temp,YEAR
	rcall 	tetradaL

	ldi		zh, HIGH (2*space)
	ldi		zl, LOW (2*space)
	rcall 	write_simbol_LCD


	ldi		left_right,(1<<E2)

	ldi		zh, HIGH (2*space)
	ldi		zl, LOW (2*space)
	rcall 	write_simbol_LCD

	lds 	temp,HOUR
	rcall 	tetradaH

	lds 	temp,HOUR
	rcall 	tetradaL

	ldi 	byte, 0
	rcall 	write_byte
	ldi 	byte, 0b01000010
	rcall 	write_byte
	ldi 	byte, 0
	rcall 	write_byte
	ldi 	byte, 0
	rcall 	write_byte

	lds 	temp,MIN
	rcall 	tetradaH

	lds 	temp,MIN
	rcall 	tetradaL

	ldi 	byte, 0
	rcall 	write_byte
	ldi 	byte, 0b01000010
	rcall 	write_byte
	ldi 	byte, 0
	rcall 	write_byte
	ldi 	byte, 0
	rcall 	write_byte

	lds 	temp,SECOND
	rcall 	tetradaH
	
	lds 	temp,SECOND
	rcall 	tetradaL

	ret
;******************************************************************************************
;       

tetradaL:

	wdr
	andi 	temp,$0f
	cpi 	temp,0
	brne 	n1
	rcall 	num0
	ret
n1:	cpi 	temp,1
	brne 	n2
	rcall 	num1
	ret
n2:	cpi 	temp,2
	brne 	n3
	rcall 	num2
	ret
n3:	cpi 	temp,3
	brne 	n4
	rcall 	num3
	ret
n4:	cpi 	temp,4
	brne 	n5
	rcall 	num4
	ret
n5:	cpi 	temp,5
	brne 	n6
	rcall 	num5
	ret
n6:	cpi 	temp,6
	brne 	n7
	rcall 	num6
	ret
n7:	cpi 	temp,7
	brne 	n8
	rcall 	num7
	ret
n8:	cpi 	temp,8
	brne 	n9
	rcall 	num8
	ret
n9:	cpi 	temp,9
	brne 	n0
	rcall 	num9
n0:	ret
;******************************************************************************************
;       

tetradaH:

	wdr
	andi 	temp,$0f0
	cpi 	temp,$00
	brne 	n11
	rcall 	num0
	ret
n11:cpi 	temp,$10
	brne 	n22
	rcall 	num1
	ret
n22:cpi 	temp,$20
	brne 	n33
	rcall 	num2
	ret
n33:cpi 	temp,$30
	brne 	n44
	rcall 	num3
	ret
n44:cpi 	temp,$40
	brne 	n55
	rcall 	num4
	ret
n55:cpi 	temp,$50
	brne 	n66
	rcall 	num5
	ret
n66:cpi 	temp,$60
	brne 	n77
	rcall 	num6
	ret
n77:cpi 	temp,$70
	brne 	n88
	rcall 	num7
	ret
n88:cpi 	temp,$80
	brne 	n99
	rcall 	num8
	ret
n99:cpi 	temp,$90
	brne 	n00
	rcall 	num9
n00:ret
;******************************************************************************************
;    0  9       

num1:
	ldi		zh, HIGH (2*n_1)
	ldi		zl, LOW (2*n_1)
	rcall 	write_simbol_LCD
	ret
num2:
	ldi		zh, HIGH (2*n_2)
	ldi		zl, LOW (2*n_2)
	rcall 	write_simbol_LCD
	ret
num3:
	ldi		zh, HIGH (2*n_3)
	ldi		zl, LOW (2*n_3)
	rcall 	write_simbol_LCD
	ret
num4:
	ldi		zh, HIGH (2*n_4)
	ldi		zl, LOW (2*n_4)
	rcall 	write_simbol_LCD
	ret
num5:
	ldi		zh, HIGH (2*n_5)
	ldi		zl, LOW (2*n_5)
	rcall 	write_simbol_LCD
	ret
num6:
	ldi		zh, HIGH (2*n_6)
	ldi		zl, LOW (2*n_6)
	rcall 	write_simbol_LCD
	ret
num7:
	ldi		zh, HIGH (2*n_7)
	ldi		zl, LOW (2*n_7)
	rcall 	write_simbol_LCD
	ret
num8:
	ldi		zh, HIGH (2*n_8)
	ldi		zl, LOW (2*n_8)
	rcall 	write_simbol_LCD
	ret
num9:
	ldi		zh, HIGH (2*n_9)
	ldi		zl, LOW (2*n_9)
	rcall 	write_simbol_LCD
	ret
num0:
	ldi		zh, HIGH (2*n_0)
	ldi		zl, LOW (2*n_0)
	rcall 	write_simbol_LCD
	ret
;******************************************************************************************
;  TWI
;******************************************************************************************
;  START
 
start_twi:

	ldi		temp, (1<<TWINT)|(1<<TWEN)|(1<<TWSTA)
	sts		TWCR, temp

wait_start_twi:
	lds		temp, TWCR
	sbrs 	temp, TWINT
	rjmp 	wait_start_twi

	lds		temp, TWSR
	andi 	temp, 0xF8
	cpi 	temp, $08
	brne 	error_start
	ret
error_start:
	ldi		error, $0EE
	ret
;******************************************************************************************
;  REPEATED START

repeated_start:

	ldi		temp, (1<<TWINT)|(1<<TWEN)|(1<<TWSTA)
	sts		TWCR, temp

wait_repeated_start:
	lds 	temp, TWCR
	sbrs 	temp, TWINT
	rjmp 	wait_repeated_start

	lds		temp, TWSR
	andi 	temp, 0xF8
	cpi 	temp, $10
	brne 	error_repeated_start
	ret
error_repeated_start:
	ldi		error, $0EE
	ret
;******************************************************************************************
;    ()  

sla_w:

	ldi 	temp, 0b11010000
	sts 	TWDR, temp
	ldi 	temp, (1<<TWINT)|(1<<TWEN)
	sts 	TWCR, temp

wait_sla_w:
	lds 	temp, TWCR
	sbrs 	temp, TWINT
	rjmp 	wait_sla_w

	lds		temp, TWSR
	andi 	temp, 0xF8
	cpi 	temp, $18
	brne 	error_sla_w
	ret
error_sla_w:
	ldi		error, $0EE
	ret
;******************************************************************************************
;    ()  

sla_r:

	ldi 	temp, 0b11010001
	sts 	TWDR, temp
	ldi 	temp, (1<<TWINT)|(1<<TWEN)
	sts 	TWCR, temp

wait_sla_r:
	lds 	temp, TWCR
	sbrs 	temp, TWINT
	rjmp 	wait_sla_r

	lds		temp, TWSR
	andi 	temp, 0xF8
	cpi 	temp, $40
	brne 	error_sla_r
	ret
error_sla_r:
	ldi		error, $0EE
	ret
;******************************************************************************************
;   ,   
;    (     )

write_byte_twi:

	sts 	TWDR, byte
	ldi 	temp, (1<<TWINT)|(1<<TWEN)
	sts 	TWCR, temp

wait_write_byte_twi:
	lds 	temp, TWCR
	sbrs 	temp, TWINT
	rjmp 	wait_write_byte_twi

	lds		temp, TWSR
	andi 	temp, 0xF8
	cpi 	temp, $28
	brne 	error_write_byte_twi
	ret
error_write_byte_twi:
	ldi		error, $0EE
	ret
;******************************************************************************************
;        (ACK)

read_byte_twi:

	ldi 	temp, (1<<TWINT)|(1<<TWEA)|(1<<TWEN)
	sts 	TWCR, temp

wait_read_byte_twi:
	lds 	temp, TWCR
	sbrs 	temp, TWINT
	rjmp 	wait_read_byte_twi

	lds		temp, TWSR
	andi 	temp, 0xF8
	cpi 	temp, $50
	brne 	error_read_byte_twi
	ret
error_read_byte_twi:
	ldi		error, $0EE
	ret
;******************************************************************************************
;        (NACK)
;(   )

last_byte_twi:

	ldi 	temp, (1<<TWINT)|(1<<TWEN)|(0<<TWEA)
	sts 	TWCR, temp

wait_last_byte_twi:
	lds		temp, TWCR
	sbrs 	temp, TWINT
	rjmp 	wait_last_byte_twi

	lds		temp, TWSR
	andi 	temp, 0xF8
	cpi 	temp, $58
	brne 	error_last_byte_twi
	ret
error_last_byte_twi:
	ldi		error, $0EE
	ret
;******************************************************************************************
;  
;******************************************************************************************
;  

pause:

d_3:
	clr r30
d_2:
	clr r29
d_1:
	wdr
	dec r29
	brne d_1
	dec r30
	brne d_2
	dec delay
	brne d_3
	ret
;******************************************************************************************
;  

pause_1:

d_31:
	wdr
	dec 	delay
	brne 	d_31
	ret
;******************************************************************************************
;     
;******************************************************************************************
.CSEG
.ORG $4000
picture_mas:
	.DB	0xFF,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01
	.DB	0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01
	.DB	0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01
	.DB	0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01
	.DB	0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01
	.DB	0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01
	.DB	0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01
	.DB	0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0xFF		

	.DB	0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xC0,0xE0,0xC0,0xE0,0xF0,0xF0,0xF0
	.DB	0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xE0,0xE0,0xE0,0xC0,0x80,0x00
	.DB	0x00,0x00,0x00,0x80,0x00,0x00,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0x80
	.DB	0x00,0x80,0x80,0x00,0x00,0x80,0x00,0x00,0x80,0x00,0x00,0x00,0x00,0x80,0x00,0x00
	.DB	0x80,0x00,0x00,0x80,0x00,0x80,0x00,0x80,0x80,0x80,0x00,0x80,0x80,0x00,0x00,0x80
	.DB	0x00,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0x80,0x00
	.DB	0x00,0x00,0x80,0x00,0x80,0x00,0x00,0x80,0x80,0x80,0x00,0x80,0x00,0x00,0x80,0x00
	.DB	0x80,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0x80,0x3F

	.DB	0x1F,0xC0,0xE0,0xE0,0xFC,0xFE,0xF3,0xE3,0xE3,0xE3,0xE3,0xAF,0x6F,0xFF,0xFF,0xFF
	.DB	0xBF,0xBF,0xFF,0xFF,0x7F,0x7F,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	.DB	0xFF,0xF6,0xF4,0x1F,0x21,0xE2,0x61,0x6F,0x60,0x6F,0x64,0x6F,0x60,0x6F,0x65,0x68
	.DB	0x60,0x6F,0x62,0x61,0x67,0x68,0x67,0x60,0x6A,0x67,0x60,0x6E,0x61,0x6F,0x60,0x67
	.DB	0x6A,0x6B,0x60,0x6F,0x65,0x68,0x60,0x60,0x6F,0x60,0x60,0x6F,0x62,0x61,0x67,0x68
	.DB	0x67,0x60,0x6F,0x62,0x6F,0x60,0x6F,0x64,0x6F,0x60,0x6F,0x65,0x68,0x64,0x6A,0x6F
	.DB	0x60,0x60,0x6F,0x64,0x6F,0x60,0x60,0x60,0x6F,0x60,0x67,0x6A,0x6B,0x60,0x6D,0x62
	.DB	0x6D,0x60,0x6F,0x62,0x6F,0x60,0x6F,0x64,0x6F,0x60,0x6F,0x65,0x68,0x64,0x6A,0x6F

	.DB	0xFE,0x3F,0x3F,0x3F,0xBF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFE,0xF9,0x77,0x37
	.DB	0x03,0x03,0x01,0x00,0x00,0x00,0x00,0x01,0x07,0x0F,0x13,0x01,0x00,0x00,0x01,0x07
	.DB	0xD7,0x0E,0x08,0xC0,0x00,0x10,0x0F,0xF8,0x00,0x00,0x80,0xE0,0xF8,0xFE,0xFF,0xFF
	.DB	0xFF,0xFE,0x00,0x00,0x00,0x00,0x00,0xC0,0xF0,0xFE,0xFF,0xFF,0xFF,0xFE,0x00,0x00
	.DB	0x00,0xE0,0xF0,0xF8,0xFC,0x7C,0x3E,0x1E,0x1F,0x0F,0x0F,0x0F,0x0F,0x1F,0x1E,0x1E
	.DB	0x3E,0x7C,0xFC,0xF8,0xF0,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	.DB	0x80,0xC0,0xF0,0xFC,0xFE,0xFF,0xFF,0xFE,0x00,0x00,0x06,0x0F,0x0F,0x0F,0x0F,0x0F
	.DB	0x0F,0x0F,0xFF,0xFF,0xFF,0xFF,0xFF,0x0F,0x0F,0x0F,0x0F,0x0F,0x0F,0x0F,0x06,0xF0
	
	.DB	0x3F,0xE0,0x00,0x00,0x01,0x3F,0xFF,0xFF,0xFF,0xFF,0xFF,0x3F,0x3F,0x00,0x00,0xE0
	.DB	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	.DB	0x00,0x01,0x01,0xC1,0xE0,0xE0,0xF9,0xFF,0xFC,0xFF,0xFF,0x7F,0x1F,0xFF,0xFF,0xFF
	.DB	0xFF,0xFF,0x80,0xE0,0xF8,0xFE,0xFF,0xFF,0x3F,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,0x00
	.DB	0x00,0x00,0x01,0x01,0x00,0x00,0x00,0x30,0x78,0x78,0xFC,0xFC,0xFC,0xFC,0x78,0x78
	.DB	0x30,0x00,0x01,0x07,0xFF,0xFF,0xFF,0xFC,0x00,0x00,0x00,0x00,0x80,0xE0,0xF8,0xFE
	.DB	0xFF,0xFF,0x3F,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	.DB	0x00,0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF
	
	.DB	0xFC,0x01,0x03,0x04,0x18,0x20,0x40,0x81,0x87,0x07,0x07,0x00,0x00,0x00,0x00,0x00
	.DB	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80
	.DB	0x80,0xE4,0xE7,0xFB,0xFF,0xFF,0x7F,0x3F,0x0F,0x03,0x01,0x00,0x00,0xFF,0xFF,0xFF
	.DB	0xFF,0xFF,0xFF,0x7F,0x1F,0x07,0x03,0x00,0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,0x00
	.DB	0x00,0x70,0xF8,0xF8,0xF0,0xE0,0xE0,0xC0,0xC0,0x80,0x80,0x80,0x80,0xC0,0xC0,0xC0
	.DB	0xE0,0xF0,0xFC,0xFF,0x7F,0x3F,0x0F,0x81,0xE0,0xF8,0xFC,0xFF,0xFF,0x3F,0x1F,0x07
	.DB	0x01,0x00,0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	.DB	0x00,0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF

	.DB	0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x02,0x02,0x04,0x04,0x04,0x0C
	.DB	0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x04,0x04,0x04,0x02,0x03,0x01,0x00
	.DB	0x00,0x03,0x07,0x07,0x03,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x07,0x07
	.DB	0x07,0x03,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x07,0x07,0x07,0x03,0x00,0x00
	.DB	0x00,0x00,0x00,0x01,0x01,0x03,0x03,0x03,0x07,0x07,0x07,0x07,0x07,0x07,0x03,0x03
	.DB	0x03,0x01,0x01,0x00,0x00,0x00,0x00,0x03,0x07,0x07,0x07,0x03,0x00,0x00,0x00,0x00
	.DB	0x00,0x00,0x00,0x03,0x07,0x07,0x07,0x03,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	.DB	0x00,0x00,0x03,0x07,0x07,0x07,0x03,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF

	.DB	0xFF,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80
	.DB	0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80
	.DB	0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80
	.DB	0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80
	.DB	0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80
	.DB	0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80
	.DB	0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80
	.DB	0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0xFF
;******************************************************************************************
;
;******************************************************************************************
.CSEG
.ORG $4200
simbol_table:
n_0:		.DB 0b00111110, 0b01000001, 0b01000001, 0b01000001	; simbol 0	
			.DB 0b00111110, 0b00000000,	0b00000000,	0b00000000
	 
n_1:		.DB 0b00000000,	0b00000000,	0b00000010,	0b01111111	; 1	
			.DB 0b00000000,	0b00000000,	0b00000000,	0b00000000

n_2:		.DB 0b01100010, 0b01010001, 0b01001001, 0b01000101	; 2
			.DB 0b01000010, 0b00000000, 0b00000000, 0b00000000

n_3:		.DB 0b00100001, 0b01000001, 0b01000101, 0b01001011	; 3
			.DB 0b00110001, 0b00000000, 0b00000000, 0b00000000

n_4:		.DB 0b00001100, 0b00001010, 0b00001001, 0b00001000	; 4
			.DB 0b01111111, 0b00000000, 0b00000000, 0b00000000

n_5:		.DB 0b00100111, 0b01000101, 0b01000101, 0b01000101	; 5
			.DB 0b00111001, 0b00000000, 0b00000000, 0b00000000

n_6:		.DB 0b00111110, 0b01001001, 0b01001001, 0b01001001	; 6
			.DB 0b00110010, 0b00000000, 0b00000000, 0b00000000

n_7:		.DB 0b01000001, 0b00100001, 0b00010001, 0b00001001	; 7
			.DB 0b00000111, 0b00000000, 0b00000000, 0b00000000

n_8:		.DB 0b00110110, 0b01001001, 0b01001001, 0b01001001	; 8
			.DB 0b00110110, 0b00000000, 0b00000000, 0b00000000

n_9:		.DB 0b00100110, 0b01001001, 0b01001001, 0b01001001	; 9
			.DB 0b00111110, 0b00000000, 0b00000000, 0b00000000

n_dot:		.DB 0b00000000, 0b00000000, 0b01100000, 0b01100000	; 
			.DB 0b00000000, 0b00000000, 0b00000000, 0b00000000

n_z:		.DB 0b00001000, 0b00101010, 0b00011100, 0b00101010	; *
			.DB 0b00001000, 0b00000000, 0b00000000, 0b00000000

n_r:		.DB 0b00010100, 0b00111110, 0b00010100, 0b00111110	; #
			.DB 0b00010100, 0b00000000, 0b00000000, 0b00000000

n_min:		.DB 0b00000000, 0b00001000, 0b00001000, 0b00001000	; -
			.DB 0b00001000, 0b00000000, 0b00000000, 0b00000000

two_dot:	.DB 0b00000000, 0b00000000, 0b01100110, 0b01100110	; 
			.DB 0b00000000, 0b00000000, 0b00000000, 0b00000000

arrow_r:	.DB 0x00, 0x08, 0x08, 0x08, 0x6B, 0x3E, 0x1C, 0x08	; >

arrow_l:	.DB 0x08, 0x1C, 0x3E, 0x6B, 0x08, 0x08, 0x08, 0x00	; <

space:		.DB 0b00000000, 0b00000000, 0b00000000, 0b00000000	; 
			.DB 0b00000000, 0b00000000, 0b00000000, 0b00000000
;******************************************************************************************
.exit
