//*****************************************************************************************
//   
//*****************************************************************************************
void write_byte(void)
{	
    _WDR();					//   
    DDRC = 0;				//    , 
							//    ,  
    PORTC = 0xFF;			//     C
    PORTD = 0x50;			//       
    left_right |= RES_OFF;
    PORTG = left_right;		//   
    __delay_cycles(2);
    PORTD |= E;				//   /
    __delay_cycles(2);
    while (PINC & 0x80);	//     
    PORTD = 0x50;			//    /  
							//     
    __delay_cycles(2);
    DDRC = 0xFF;			//    , 
							//    ,  
    data_comm |= LIGHT_ON; 	//   
    PORTD = data_comm;		//    
    PORTC = byte;
    __delay_cycles(2);
    PORTD |= E; 			//   /
    __delay_cycles(2);
    PORTD = data_comm; 		//    /  
							//     
    __delay_cycles(2);
}
//*****************************************************************************************
void write_comm_L(void)
{
    left_right = E1;
    data_comm = 0;
    write_byte();
}
//*****************************************************************************************
void write_comm_R(void)
{
    left_right = E2;
    data_comm = 0;
    write_byte();
}
//*****************************************************************************************
void write_data_L(void)
{
    left_right = E1;
    data_comm = A0;
    write_byte();
}
//*****************************************************************************************
void write_data_R(void)
{
    left_right = E2;
    data_comm = A0;
    write_byte();
}
//*****************************************************************************************
void initial_LCD(void)
{
    _WDR();
    PORTD =LIGHT_ON;	
    PORTG = RES_OFF;
    PORTG = RES_ON;
    __delay_cycles(2);
    PORTG = RES_OFF;
    __delay_cycles(20);
    byte = START_LINE;	
    write_comm_L();
    write_comm_R();
    byte = DISPLAY_ON;
    write_comm_L();
    write_comm_R();
    byte = SET_PAGE;	
    write_comm_L();
    write_comm_R();
    byte = SET_ADDRESS;	
    write_comm_L();
    write_comm_R();
}
//*****************************************************************************************
void black_screen(void)
{
    for(page_lcd =0; page_lcd < 8; page_lcd ++){
        byte = page_lcd | SET_PAGE;
        write_comm_L();
        write_comm_R();
        byte = SET_ADDRESS;
        write_comm_R();
        write_comm_L();
        for(col = 0; col < 64; col++){
            byte = 0xFF;
            write_data_L();
            write_data_R();
        }
    }
}
//*****************************************************************************************
void clean_screen(void)
{
    for(page_lcd =0; page_lcd < 8; page_lcd ++){
        byte = page_lcd | SET_PAGE;
        write_comm_R();
        write_comm_L();
        byte = SET_ADDRESS;
        write_comm_R();
        write_comm_L();
        for(col = 0; col < 64; col++){
            byte = 0x00;
            write_data_R();
            write_data_L();
        }
    }
    byte = SET_PAGE;
    write_comm_R();
    write_comm_L();
    byte = SET_ADDRESS;
    write_comm_R();
    write_comm_L();
}
//*****************************************************************************************
void picture(void)
{
    for(page_lcd =0; page_lcd < 8; page_lcd ++){
        byte = page_lcd | SET_PAGE;
        write_comm_L();
        write_comm_R();
        byte = SET_ADDRESS;
        write_comm_L();
        write_comm_R();
        for(col = 0; col < 64; col++){
            byte = Picture[page_lcd][col];
            write_data_L();
            byte = Picture[page_lcd][col + 64];
            write_data_R();
        }
    }
}
//*****************************************************************************************
//     

void write_LCD(flash unsigned char simbol[])
{
	static unsigned char col;
	for (col = 0; col < 8; col ++){
        if (inwert == 0)
            byte = simbol[col];
        if (inwert == 0xFF)
            byte = ~(simbol[col]);
        column ++;
	    write_byte();
  	}
}
//*****************************************************************************************
//         (    )

void write_LCD_1(flash unsigned char simbol[])
{
	static unsigned char col;
	for (col = 0; col < 8; col ++){
		byte = (simbol[col]);
        column_1 ++;
	    write_byte();
  	}
}
//*****************************************************************************************
void display_position(unsigned char string, unsigned char font_reticle_L,
				   unsigned char font_reticle_R)
{
	font_reticle_L *= 8;
	font_reticle_R *= 8;
	
	byte = START_LINE;	
    write_comm_L();
    write_comm_R();
    byte = string | SET_PAGE;
    write_comm_L();
    write_comm_R();
    byte = SET_ADDRESS;
    byte = font_reticle_R | SET_ADDRESS;
    write_comm_R();
    byte = font_reticle_L | SET_ADDRESS;
    write_comm_L();
    data_comm = A0;
}
//*****************************************************************************************
