//*****************************************************************************************
//   TWI
//*****************************************************************************************
//   START

start_twi(void)
{
    TWCR = 0xA4;                //  1010 0100(1<<TWINT)|(1<<TWEN)|(1<<TWSTA);
    while (!(TWCR & 0x80));

    if ((TWSR & 0xF8) == 0x08)
        return 0;
    else
        return 0xEE;
}
//*****************************************************************************************
//   REPEATED START

rep_start(void)
{
    TWCR = 0xA4;                //  1010 0100(1<<TWINT)|(1<<TWEN)|(1<<TWSTA)
    while (!(TWCR & 0x80));

    if ((TWSR & 0xF8) == 0x10)
        return 0;
    else
        return 0xEE;
}
//*****************************************************************************************
//      

sla_w(void)
{
    TWDR = 0xD0;                //  1101 0000
    TWCR = 0x84;                //  1000 0100(1<<TWINT)|(1<<TWEN)
    while (!(TWCR & 0x80));

    if ((TWSR & 0xF8) == 0x18)
        return 0;
    else
        return 0xEE;
}
//*****************************************************************************************
//      

sla_r(void)
{
    TWDR = 0xD1;  //  1101 0001
    TWCR = 0x84;                //  1000 0100(1<<TWINT)|(1<<TWEN)
    while (!(TWCR & 0x80));

    if ((TWSR & 0xF8) == 0x40)
        return 0;
    else
        return 0xEE;
}
//*****************************************************************************************
//    ,   
//     (   ),
//       

write_byte_twi(void)
{
    TWDR = byte;
    TWCR = 0x84;                //  1000 0100(1<<TWINT)|(1<<TWEN)
    while (!(TWCR & 0x80));

    if ((TWSR & 0xF8) == 0x28)
        return 0;
    else
        return 0xEE;
}
//*****************************************************************************************
read_byte_twi(void)
{
    TWCR = 0xC4;                //  1100 0100(1<<TWINT)|(1<<TWEA)|(1<<TWEN)
    while (!(TWCR & 0x80));

    if ((TWSR & 0xF8) == 0x50)
        return 0;
    else
        return 0xEE;
}
//*****************************************************************************************
last_byte_twi(void)
{
    TWCR = 0x84;                //  1010 0100(1<<TWINT)|(1<<TWEN)
    while (!(TWCR & 0x80));

    if ((TWSR & 0xF8) == 0x58)
        return 0;
    else
        return 0xEE;
}
//*****************************************************************************************
