//*****************************************************************************************
//  
//*****************************************************************************************
//         INT3
//       DS1307  
// TWI       12864

#pragma vector = INT3_vect
__interrupt void  ext_int_3 (void)
{
	read_data_clock();
}
//*****************************************************************************************
#define FIRST_COLUMN 0x80
#define LAST_COLUMN 0x10

#define KEY_IN 	PINA
#define KEY_OUT	PORTA

//#define DELAY_KEYB 0x80
#define DELAY_KEYB 0xD0

static unsigned char column_key;	
static unsigned char row_data;

#pragma vector = TIMER0_OVF_vect
__interrupt void tim0_ovf (void)
{
    TCCR0	= 0x00;  			//   T0

    _WDR();

    TCNT0 = DELAY_KEYB;

    KEY_OUT = ~column_key;
    _NOP();
    row_data =~KEY_IN & 0x0F;

    switch(column_key)
    {
        case(0x80):
            switch(row_data)
            {
                case(0x00): key_simb = 1; break;
                case(0x01): key_simb = '>'; break;
                case(0x02): key_simb = '<'; break;
                case(0x04): key_simb = '.'; break;
                case(0x08): key_simb = '-'; break;	// ENTER
            } break;
         case(0x40):
            switch(row_data)
            {
                case(0x00): key_simb = 2; break;
                case(0x01): key_simb = '3'; break;
                case(0x02): key_simb = '6'; break;
                case(0x04): key_simb = '9'; break;
                case(0x08): key_simb = '#'; break;	// ESC
            } break;
        case(0x20):
            switch(row_data)
            {
                case(0x00): key_simb = 3; break;
                case(0x01): key_simb = '2'; break;
                case(0x02): key_simb = '5'; break;
                case(0x04): key_simb = '8'; break;
                case(0x08): key_simb = '0'; break;
            } break;
        case(0x10):
            switch(row_data)
            {
                case(0x00): key_simb = 4; break;
                case(0x01): key_simb = '1'; break;
                case(0x02): key_simb = '4'; break;
                case(0x04): key_simb = '7'; break;
                case(0x08): key_simb = '*'; break;
            } break;
   	}
    column_key >>= 1;
    if (column_key == LAST_COLUMN >>1)
        column_key = FIRST_COLUMN;
	
    TCCR0	= 0x05;  	// 0000 0101   T0 
    					//     1024
}
//*****************************************************************************************
