//*****************************************************************************************
//   TWI
//*****************************************************************************************
//   START

int start_twi(void)
{
    TWCR = 0xA4;                //  1010 0100(1<<TWINT)|(1<<TWEN)|(1<<TWSTA);
    while (!(TWCR & 0x80));

    if ((TWSR & 0xF8) == 0x08)
        return 0;
    else
        return ERROR;
}
//*****************************************************************************************
//   REPEATED START

int rep_start(void)
{
    TWCR = 0xA4;                //  1010 0100(1<<TWINT)|(1<<TWEN)|(1<<TWSTA)
    while (!(TWCR & 0x80));

    if ((TWSR & 0xF8) == 0x10)
        return 0;
    else
        return ERROR;
}
//*****************************************************************************************
//   STOP

void stop_twi(void)
{
    TWCR = 0x94;                //  1001 0100(1<<TWINT)|(1<<TWEN)|(1<<TWSTO)

    if (TWSR == 0x00)
		TWCR = 0x90;                //  1001 0000(1<<TWINT)|(1<<TWSTO)
}
//*****************************************************************************************
//      

int sla_w(unsigned char write_addr)
{
    TWDR = write_addr;
    TWCR = 0x84;                //  1000 0100(1<<TWINT)|(1<<TWEN)
    while (!(TWCR & 0x80));

    if ((TWSR & 0xF8) == 0x18)
        return 0;
    else
        return ERROR;
}
//*****************************************************************************************
//      

int sla_r(unsigned char read_addr)
{
    TWDR = read_addr;
    TWCR = 0x84;                //  1000 0100(1<<TWINT)|(1<<TWEN)
    while (!(TWCR & 0x80));

    if ((TWSR & 0xF8) == 0x40)
        return 0;
    else
        return ERROR;
}
//*****************************************************************************************
//    ,   
//     (   ),

int write_byte_twi(unsigned char write_data)
{
    TWDR = write_data;
    TWCR = 0x84;                //  1000 0100(1<<TWINT)|(1<<TWEN)
    while (!(TWCR & 0x80));

    if ((TWSR & 0xF8) == 0x28)
        return 0;
    else
        return ERROR;
}
//*****************************************************************************************
int read_byte_twi()
{
    TWCR = 0xC4;                //  1100 0100(1<<TWINT)|(1<<TWEA)|(1<<TWEN)
    while (!(TWCR & 0x80));

    if ((TWSR & 0xF8) == 0x50)
        return 0;
    else
        return ERROR;
}
//*****************************************************************************************
int last_byte_twi(void)
{
    TWCR = 0x84;                //  1010 0100(1<<TWINT)|(1<<TWEN)
    while (!(TWCR & 0x80));

    if ((TWSR & 0xF8) == 0x58)
        return 0;
    else
        return ERROR;
}
//*****************************************************************************************
